# A main workflow for fixing duplicated pipelines and setting pretty stage names

workflow:
  name: ${pipelineName}

  # Cancel the workflow on a new commit, but only if not jobs w/ `interruptible: false` have started
  auto_cancel:
    on_new_commit: conservative
  
  rules:
    # Fix duplicated pipelines on merge requests
    - if: $CI_PIPELINE_SOURCE == 'push' && $CI_OPEN_MERGE_REQUESTS
      when: never
  
    # Branches
    - if: $CI_COMMIT_BRANCH
      variables:
        CI_PIPELINE_TYPE: branch
        pipelineName: Pipeline for Branch '${CI_COMMIT_BRANCH}'
  
    # Merge Requests
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      variables:
        CI_PIPELINE_TYPE: merge_request
        pipelineName: Pipeline for Merge Request '${CI_MERGE_REQUEST_TITLE}'
  
    # Tags
    - if: $CI_COMMIT_TAG_MESSAGE
      variables:
        CI_PIPELINE_TYPE: tag
        pipelineName: Release Pipeline for Tag '${CI_COMMIT_TAG}'
  
    # Schedules
    - if: $CI_PIPELINE_SOURCE == 'schedule'
      variables:
        CI_PIPELINE_TYPE: scheduled
        pipelineName: Scheduled Pipeline for Branch '${CI_COMMIT_BRANCH}'
  
    # Unknown pipeline type and source
    - variables:
        CI_PIPELINE_TYPE: unknown
        pipelineName: Unknown Pipeline From '${CI_PIPELINE_SOURCE}'
